Index: pyside/tests/CMakeLists.txt
===================================================================
--- pyside.orig/tests/CMakeLists.txt	2010-12-29 14:57:30.000000000 -0300
+++ pyside/tests/CMakeLists.txt	2010-12-29 14:59:36.189429354 -0300
@@ -37,7 +37,7 @@
         else()
             message(WARNING "Invalid call of macro PYSIDE_TEST")
         endif()
-        set(TEST_CMD ${XVFB_EXEC} ${SHIBOKEN_PYTHON_INTERPRETER} "${CMAKE_CURRENT_SOURCE_DIR}/${ARGV0}")
+        set(TEST_CMD ${XVFB_EXEC} ${PYTHON_INTERP} "${CMAKE_CURRENT_SOURCE_DIR}/${ARGV0}")
         add_test(${TEST_NAME} ${TEST_CMD})
         set_tests_properties(${TEST_NAME} PROPERTIES
                              TIMEOUT ${CTEST_TESTING_TIMEOUT}
Index: pyside/CMakeLists.txt
===================================================================
--- pyside.orig/CMakeLists.txt	2010-12-29 14:57:45.000000000 -0300
+++ pyside/CMakeLists.txt	2010-12-29 15:01:59.849443474 -0300
@@ -133,9 +133,12 @@
             echo "Source package created at ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2.\n"
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 
+string(REGEX REPLACE "/targets/.*/usr" "/usr" PYTHON_INTERP ${SHIBOKEN_PYTHON_INTERPRETER})
+message(STATUS "Building for Python ${PYTHON_INTERP}")
+
 if (NOT SITE_PACKAGE)
     execute_process(
-        COMMAND ${SHIBOKEN_PYTHON_INTERPRETER} -c "from distutils import sysconfig; \\
+        COMMAND ${PYTHON_INTERP} -c "from distutils import sysconfig; \\
             print sysconfig.get_python_lib(1,0,prefix='${CMAKE_INSTALL_PREFIX}')"
         OUTPUT_VARIABLE SITE_PACKAGE
         OUTPUT_STRIP_TRAILING_WHITESPACE)
